//  ======================================================================== //
//                                                                           //
//    File      : path.cpp                                                   //
//    Purpose   :                                                            //
//    Time-stamp: <Thu May/09/2002 00:48 MET Coder@ReallySoft.de>            //
//                                                                           //
//    (C) May 2002 by Ralf Westram                                           //
//                                                                           //
//    Permission to use, copy, modify, distribute and sell this software     //
//    and its documentation for any purpose is hereby granted without fee,   //
//    provided that the above copyright notice appear in all copies and      //
//    that both that copyright notice and this permission notice appear      //
//    in supporting documentation.                                           //
//                                                                           //
//    Ralf Westram makes no representations about the suitability of this    //
//    software for any purpose.  It is provided "as is" without express or   //
//    implied warranty.                                                      //
//                                                                           //
//  ======================================================================== //

#include "path.h"

#include <algorithm>


using namespace std;
using namespace rs;
using namespace rs::sys_dep;

// start of implementation of class Path:

// ---------------------
//      Path::Path()
// ---------------------
Path::Path()
{
    const char *path = getenv("PATH");
    init(path);
}

// -------------------------------------
//      Path::Path(const char *path)
// -------------------------------------
Path::Path(const char *path)
{
    init(path);
}

struct str_empty { bool operator()(const string& s) { return s.empty(); } };

// ------------------------------------------
//      void Path::init(const char *path)
// ------------------------------------------
void Path::init(const char *path)
{
    dirs.clear();

    const char *start     = path;
    char        delimiter = strchr(start, ';') ? ';' : ':';

    while (1) {
        const char *sep = strchr(start, delimiter);
        if (!sep) break;
        dirs.push_back(string(start, sep-start));
        start = sep+1;
    }
    dirs.push_back(start);

    //     cout << "Dirs[1]:\n"; copy(dirs.begin(), dirs.end(), ostream_iterator<string>(cout, "\n"));

    // remove empty directories from path :
    dirs.erase(remove_if(dirs.begin(), dirs.end(), str_empty()), dirs.end());
}

// -end- of implementation of class Path.

