//  ======================================================================== //
//                                                                           //
//    File      : path.h                                                     //
//    Purpose   :                                                            //
//    Time-stamp: <Wed Nov/13/2002 05:45 MET Coder@ReallySoft.de>            //
//                                                                           //
//    (C) May 2002 by Ralf Westram                                           //
//                                                                           //
//    Permission to use, copy, modify, distribute and sell this software     //
//    and its documentation for any purpose is hereby granted without fee,   //
//    provided that the above copyright notice appear in all copies and      //
//    that both that copyright notice and this permission notice appear      //
//    in supporting documentation.                                           //
//                                                                           //
//    Ralf Westram makes no representations about the suitability of this    //
//    software for any purpose.  It is provided "as is" without express or   //
//    implied warranty.                                                      //
//                                                                           //
//  ======================================================================== //

#ifndef PATH_H
#define PATH_H

#ifndef VECTOR
#include <vector>
#endif
#ifndef STRING
#include <string>
#endif

namespace rs {
    namespace sys_dep {

        /// a portable way to inspect the PATH environment
        class Path {
        private:
            std::vector<std::string> dirs;

            void init(const char *path);
        public:
            Path();
            Path(const char *path);
            virtual ~Path() {}

            std::vector<std::string>::const_iterator begin() const { return dirs.begin(); }
            std::vector<std::string>::const_iterator end() const { return dirs.end(); }
        };
    };
}; // end of namespace rs

#else
#error path.h included twice
#endif // PATH_H

